<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Session;

class SetLocale
{
    /**
     *
     * Handle an incoming request.
     *
     * @param Request $request
     * @param Closure $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
            if (Session::has('locale')) {
                $locale = Session::get('locale', config('app.locale'));
            } else {
                if (config('app.dynamic_locale')) {
                    $locale = substr($request->server('HTTP_ACCEPT_LANGUAGE'), 0, 2);

                    if (!in_array($locale, config('app.available_locales'))) {
                        $locale = config('app.locale');
                    }
                }
            }

        App::setLocale($locale);

        return $next($request);
    }
}
